#!/bin/bash

if [ "$1" = "" ]; then
	echo "usage: level.sh NNN"
	exit 1
fi

NNN=$1
L=level$NNN
cd $L || exit 2

IT=$L-input.txt
IB=$L-input.bin
IH=$L-input.html
ST=$L-solution.txt
SB=$L-solution.bin
SH=$L-solution.html
VT=$L-validation.txt

echo "================ validation"
pipeleak validate $IT -o $VT
cat $VT

echo "================ input binary"
pipeleak convert $IT -ob $IB -oh $IH
hexdump -ve '16/1 "%02x " "\n"' $IB

echo "================ solution text"
pipeleak solve $IT -o $ST
icdiff $IT $ST

echo "================ solution binary"
pipeleak solve $IT -ob $SB -oh $SH
icdiff <(hexdump -ve '16/1 "%02X " "\n"' $IB) <(hexdump -ve '16/1 "%02X " "\n"' $SB)

cd ..
